# Preview API

Show preview API for:

- 478: Key Derivation Function API (Preview)
- 487: Scoped Values (Fourth Preview)
- 494: Module Import Declarations (Second Preview)
- 495: Simple Source Files and Instance Main Methods (Fourth Preview)
- 499: Structured Concurrency (Fourth Preview)
- Toggle all

## Contents

- Interfaces
- Classes
- Enum Classes
- Exception Classes
- Methods
- Enum Constants

Interfaces
Interface
Preview Feature
Description
java.lang.ScopedValue.CallableOpPREVIEW
Scoped Values
An operation that returns a result and may throw an exception.
java.util.concurrent.StructuredTaskScope.SubtaskPREVIEW
Structured Concurrency
Represents a subtask forked with `StructuredTaskScope.fork(Callable)`PREVIEW.
javax.crypto.KDFParametersPREVIEW
Key Derivation Function API
A specification of Key Derivation Function (`KDF`PREVIEW) parameters.
javax.crypto.spec.HKDFParameterSpecPREVIEW
Key Derivation Function API
Parameters for the combined Extract, Expand, or Extract-then-Expand operations of the HMAC-based Key Derivation Function (HKDF).

Classes
Class
Preview Feature
Description
java.io.IOPREVIEW
Simple Source Files and Instance Main Methods
A collection of static convenience methods that provide access to system console for implicitly declared classes.
java.lang.ScopedValuePREVIEW
Scoped Values
A value that may be safely and efficiently shared to methods without using method parameters.
java.lang.ScopedValue.CarrierPREVIEW
Scoped Values
A mapping of scoped values, as keys, to values.
java.util.concurrent.StructuredTaskScopePREVIEW
Structured Concurrency
A basic API for structured concurrency.
java.util.concurrent.StructuredTaskScope.ShutdownOnFailurePREVIEW
Structured Concurrency
A `StructuredTaskScope` that captures the exception of the first subtask to failPREVIEW.
java.util.concurrent.StructuredTaskScope.ShutdownOnSuccessPREVIEW
Structured Concurrency
A `StructuredTaskScope` that captures the result of the first subtask to complete successfullyPREVIEW.
javax.crypto.KDFPREVIEW
Key Derivation Function API
This class provides the functionality of a Key Derivation Function (KDF), which is a cryptographic algorithm for deriving additional keys from input keying material (IKM) and (optionally) other data.
javax.crypto.KDFSpiPREVIEW
Key Derivation Function API
This class defines the Service Provider Interface (SPI) for the Key Derivation Function (`KDF`PREVIEW) class.
javax.crypto.spec.HKDFParameterSpec.BuilderPREVIEW
Key Derivation Function API
This `Builder` builds `Extract` and `ExtractThenExpand` objects.
javax.crypto.spec.HKDFParameterSpec.ExpandPREVIEW
Key Derivation Function API
Defines the input parameters of an Expand operation as defined in RFC 5869.
javax.crypto.spec.HKDFParameterSpec.ExtractPREVIEW
Key Derivation Function API
Defines the input parameters of an Extract operation as defined in RFC 5869.
javax.crypto.spec.HKDFParameterSpec.ExtractThenExpandPREVIEW
Key Derivation Function API
Defines the input parameters of an Extract-then-Expand operation as defined in RFC 5869.

Enum Classes
Enum Class
Preview Feature
Description
java.util.concurrent.StructuredTaskScope.Subtask.StatePREVIEW
Structured Concurrency
Represents the state of a subtask.

Exception Classes
Exception Class
Preview Feature
Description
java.util.concurrent.StructureViolationExceptionPREVIEW
Structured Concurrency
Thrown when a structure violation is detected.

Methods
Method
Preview Feature
Description
com.sun.source.tree.ImportTree.isModule()PREVIEW
Module Import Declarations
Returns true if this is an module import declaration..
java.io.Console.print(Object)PREVIEW
Simple Source Files and Instance Main Methods
Writes a string representation of the specified object to this console's output stream and then flushes the console.
java.io.Console.println()PREVIEW
Simple Source Files and Instance Main Methods
Terminates the current line in this console's output stream using `System.lineSeparator()` and then flushes the console.
java.io.Console.println(Object)PREVIEW
Simple Source Files and Instance Main Methods
Writes a string representation of the specified object to this console's output stream, terminates the line using `System.lineSeparator()` and then flushes the console.
java.io.Console.readln()PREVIEW
Simple Source Files and Instance Main Methods
Reads a single line of text from this console.
java.io.Console.readln(String)PREVIEW
Simple Source Files and Instance Main Methods
Writes a prompt as if by calling `print`, then reads a single line of text from this console.
jdk.jshell.JShellConsole.readLine()PREVIEW
Simple Source Files and Instance Main Methods
Reads a single line of text from the console.

Enum Constants
Enum Constant
Preview Feature
Description
jdk.jshell.Snippet.SubKind.MODULE_IMPORT_SUBKINDPREVIEW
Module Import Declarations
Import Module Declaration.